void PowerEffect();
void Shot();
void BigShot(int power);
void MaxShot();

void SemiAutoShot(
	bool button,    // 버튼 상태 (눌렸으면 true)
	int min_power,  // 에너지의 최소치
	int max_power,  // 에너지의 최대치
	int max_gauge   // 연사 게이지의 최대치
) {
	// 모은 에너지, 연사 게이지
	static int power=0, gauge=0;

	// 버튼을 누르고 있을 때:
	if (button) {
		
		// 에너지가 부족할 경우:
		// 보통 샷을 발사.
		// 구체적인 처리는 Shot 함수에서 수행하기로 함.
		if (power<min_power) Shot();
	
		// 에너지가 충분할 경우:
		// 에너지를 모은 상태를 표시함.
		// 구체적인 처리는 PowerEffect 함수에서 수행하기로 함.
		else PowerEffect();
	
		// 파워를 늘리고, 연사 게이지를 최대로 함.
		if (power<max_power) power++;
		gauge=max_gauge;
	}
	
	// 버튼을 누르고 있지 않을 때:
	else {
		
		// 에너지가 충분할 경우:
		// 에너지 샷을 발사:
		// 모아둔 에너지가 최대치에 도달했을 때는 특별한 샷을 발사.
		// 구체적인 처리는 MaxShot 함수와 BigShot 함수에서 수행하기로 함.
		if (min_power<=power) {
			if (power==max_power) MaxShot(); 
				else BigShot(power);
			gauge=0;
		}
		
		// 연사 게이지가 0보다 클 경우:
		// 보통 샷을 발사하고, 연사 게이지를 1 감소시킴.
		// 구체적인 처리는 Shot 함수에서 수행하기로 함.
		if (gauge>0) {
			Shot();
			gauge--;
		}

		// 에너지를 0으로 함.
		power=0;
	}
}

